/** Copyright © 2007-2008 eMusic.com Inc.
 
This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.  The GNU Lesser General Public License can be viewed by clicking on the following link:  http://www.gnu.org/licenses/lgpl.html#SEC4.  
 
This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 
You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**/


// implementation of nsIURIContentListener
// http://forums.mozillazine.org/viewtopic.php?p=2090958
//const EMP_MIMETYPE = "application/vnd.emusic-emusic_package"
const EMX_MIMETYPE = "application/vnd.emusic-emusic_list"

var emusic_dlmContentListener = {
  thisTimer: null,
  thisFile: null,
  
  QueryInterface: function(iid) {
    if (iid.equals(Components.interfaces.nsIURIContentListener) ||
        iid.equals(Components.interfaces.nsISupportsWeakReference) ||
        iid.equals(Components.interfaces.nsISupports))
        return this;
    throw Components.results.NS_NOINTERFACE;
  },

  onStartURIOpen: function(uri) {
    return false;
  },

  doContent: function(contentType, isContentPreferred, request, contentHandler) {
    // We handle this type
    var channel = request.QueryInterface(Components.interfaces.nsIChannel);
    var myURL = this.nsIURIToString(channel.URI)

    switch (contentType) {
      //case EMP_MIMETYPE:
      case EMX_MIMETYPE:

        var urlObj = Components.classes['@mozilla.org/network/standard-url;1']
											 .createInstance(Components.interfaces.nsIURL);
      	urlObj.spec = myURL;

        var tmpPath = this.getSpecialFolder("TmpD");
        
        tmpPath.append("emusic_emx")
        var origTmpPath = tmpPath.clone()

        if (!tmpPath.exists()) {
          try {
            tmpPath.create(0x01,0755);
          } catch(ex) {
            return false;
          }
        }

        tmpPath.append(urlObj.fileName);
        tmpPath.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0777);

        this.thisFile = tmpPath.path

        this.silentFileDownload(myURL, tmpPath.path, true, this.myListener)

        var entries = origTmpPath.directoryEntries;

        //clearTimeout(this.thisTimer)

/*        this.thisTimer = setTimeout(function() {
                                      var array = [];
                                      while(entries.hasMoreElements()) {
                                        var entry = entries.getNext();
                                        entry.QueryInterface(Components.interfaces.nsIFile);
                                        if (entry.path != tmpPath.path) {
                                          entry.remove(false);
                                        }
                                      }
                                    }, 10000);
*/
        return true;
        break;
    }
    return false;
  },

  isPreferred: function(contentType, desiredContentType) {
    // We handle this type
    switch (contentType) {
      //case EMP_MIMETYPE:
      case EMX_MIMETYPE:
        return true;
        break;
    }
    return false;
  },

  canHandleContent: function(contentType, isContentPreferred, desiredContentType) {
    // We handle this type
    switch (contentType) {
      //case EMP_MIMETYPE:
      case EMX_MIMETYPE:
        return true;
        break;
    }
    return false;
  },

  GetWeakReference: function() {
    return this;
  },
  
  nsIURIToString: function(uri) {
    var result = uri.scheme + "://";
    result += uri.host;
    if (uri.port > 0)result += uri.port;
    result += uri.path;
    return result;
  },

  getSpecialFolder: function(thisType){
    var ds = Components.classes["@mozilla.org/file/directory_service;1"].
                 getService(Components.interfaces.nsIProperties);
    return ds.get(thisType, Components.interfaces.nsILocalFile);
  },
  
  silentFileDownload: function(thisFile, thisPath, serializeFile, thisListener) {
    try {
      var obj_URI = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService)
                      .newURI(thisFile, null, null);
      var obj_TargetFile = this.getLocalFileInterface(thisPath);
    
      if (!obj_TargetFile.exists()) {
        try {
          obj_TargetFile.create(0x00,0755);
        } catch(ex) {
          return false;
        }
      }

      var obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                          .createInstance(Components.interfaces.nsIWebBrowserPersist);

      if (serializeFile) {
        var nsIWBP = Components.interfaces.nsIWebBrowserPersist;
    
        obj_Persist.persistFlags = nsIWBP.PERSIST_FLAGS_SERIALIZE_OUTPUT;
      }

    	if (thisListener) {
    	  obj_Persist.progressListener = thisListener;
    	}
    
      obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile);

    } catch (ex) {
      this.debug(ex)
      return false;
    }

    return true;
  },

  launchFile: function(url) {
		var launchEMFile = this.getLocalFileInterface(url)
		launchEMFile.launch();
  },
	
  getLocalFileInterface: function(thisPath) {
    try {
      var localFileInterface = Components.classes["@mozilla.org/file/local;1"].
                                 createInstance(Components.interfaces.nsILocalFile);

      localFileInterface.initWithPath(thisPath);

      return localFileInterface;
    } catch (ex) {
      return null;
    }
  },

  myListener: {
    STATE_STOP: Components.interfaces.nsIWebProgressListener.STATE_STOP,
    STATE_START: Components.interfaces.nsIWebProgressListener.STATE_START,
    STATE_TRANSFERRING: Components.interfaces.nsIWebProgressListener.STATE_TRANSFERRING,

    QueryInterface : function(aIID) {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsISupports))
        return this;
      throw Components.results.NS_NOINTERFACE;
    },
  
    onStateChange:function(aProgress, aRequest, aFlag, aStatus) {
      if (aFlag & this.STATE_START) {
      }
      if (aFlag & this.STATE_STOP) {
        try {
          var mimeService = Components.classes["@mozilla.org/mime;1"]                              
                    .getService(Components.interfaces.nsIMIMEService);

          var mimeInfo = mimeService.getFromTypeAndExtension(EMX_MIMETYPE, "emx");
          try {
  					mimeInfo.launchWithFile(emusic_dlmContentListener.getLocalFileInterface(emusic_dlmContentListener.thisFile))
  				} catch(ex){
  					emusic_dlmContentListener.launchFile(emusic_dlmContentListener.thisFile)
  				}
          
          //this.debug(thisLocalFile)
        } catch(ex) {
          this.debug(ex)
        }
      }
    },

    onLocationChange:function(a,b,c){},

    onProgressChange:function(a,b,c,d,e,f){

      if (this.STATE_TRANSFERRING) {
        try {
    	    //var windowType = dlm_base.getWindowType();
    
          /*var browserWindow = dlm_base.mostRecentWindow(local_common.getWindowType());

          browserWindow.document.getElementById("statusbar-display").label = 
            dlm_base.myListenerStartMsg + ": " + Math.ceil((e/f) * 100);*/

        } catch(ex) {
        }
      }
    },

    onStatusChange:function(a,b,c,d){},

    onSecurityChange:function(a,b,c){},

    onLinkIconAvailable:function(a){}
  },

  debug: function() {
    var mConsoleService = Cc["@mozilla.org/consoleservice;1"]
           .getService(Ci.nsIConsoleService)

    try {
      mConsoleService.logStringMessage("eMusic_Helper: " + Array.join(arguments, ": ") + "\n");
    } catch (ex) {
    }
  }
}

var emusic_uriLoader = Components.classes["@mozilla.org/uriloader;1"]
                         .getService(Components.interfaces.nsIURILoader);

emusic_uriLoader.registerContentListener(emusic_dlmContentListener);
